//
//  StringContains.swift
//  DebuggingDemo
//
//  Created by freund on 10/3/18.
//  Copyright © 2018 Steve. All rights reserved.
//

import Foundation

/**
 Problem 1:
 
 This String method is supposed to return true if it contains other
 as a substring.
 
 */
extension String {
  
  func contains(_ other : String) -> Bool {
    let selfChars = Array(self)
    let otherChars = Array(other)
    var otherIndex = 0
    var selfIndex = 0
    while selfIndex < selfChars.count {
      if selfChars[selfIndex] == otherChars[otherIndex] {
        otherIndex += 1
        if otherIndex == otherChars.count {
          return true
        }
      } else {
        otherIndex = 0
      }
      selfIndex += 1
    }
    return false
  }
}

/**
 Problem 2:
 
 This function does not implement binary search properly...
 
 - Parameter a : the array to search
 - Parameter key : the value to search for
 - Parameter lowerBound : smallest index to look in.
 - Parameter upperBound : largest index to look in.
 
 - Returns: index of of k if it appears in a[lowerBound], ..., a[upperBound],
 and nil otherwise.
 
 - Note: There are two errors...
 
 */
func binarySearch(_ a: [Int], key: Int, lowerBound : Int, upperBound : Int) -> Int? {
  if lowerBound >= upperBound {
    return nil
  } else {
    let midIndex = (lowerBound + upperBound) / 2
    
    if a[midIndex] > key {
      // search left half
      return binarySearch(a, key: key, lowerBound: lowerBound + 1, upperBound: midIndex)
      
    } else if a[midIndex] < key {
      // search right half
      return binarySearch(a, key: key, lowerBound: midIndex + 1, upperBound: upperBound)
      
    } else {
      // a[midIndex] == key
      return midIndex
    }
  }
}

